/*
 * Copyright (c) 1999 Jeff DeMaagd, GPL copyright.
 
 * OpenGL(R) is a registered trademark of Silicon Graphics, Inc.
 */

#include "readdxf.h"

static double x_loc = 0.0, y_loc = 0.0, z_loc = 25.0, x_rot_mouse = 0.0, y_rot_mouse = 0.0;
//static int reverse_normals = 0;
extern FILE *file_in, *file_out;
//char *file_in_name[];
int line_count, number;
GLboolean smooth = GL_TRUE;
GLboolean lighting = GL_TRUE;
GLboolean doubleBuffer = GL_TRUE;

//static GLfloat blue[4] = {0.2, 0.2, 1.0, 0.5};
//static GLfloat red[4] = {1.0, 0.2, 0.2, 0.5};
//static GLfloat green[4] = {0.2, 1.0, 0.2, 0.5};
static GLuint Data = 1;


/* ********************************************************************** */
void InitMaterials(void)
{
    static float lmodel_ambient[] = {1.0, 1.0, 1.0, 1.0};
    static float lmodel_twoside[] = {GL_FALSE};
    static float ambient[] = {0.1, 0.1, 0.1, 1.0};
    static float diffuse[] = {0.5, 1.0, 1.0, 1.0};
    static float position0[] = {0.0, 0.0, 20.0, 0.0};
    static float position1[] = {0.0, 0.0, -20.0, 0.0};
    static float front_mat_shininess[] = {60.0};
    static float front_mat_specular[] = {0.2, 0.2, 0.2, 1.0};
    static float front_mat_diffuse[] = {0.5, 0.28, 0.38, 1.0};
    
//    static float back_mat_shininess[] = {60.0};
//    static float back_mat_specular[] = {0.5, 0.5, 0.2, 1.0};
//    static float back_mat_diffuse[] = {1.0, 1.0, 0.2, 1.0};
    

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
//	glLightModelfv(GL_LIGHT_MODEL_TWO_SIDE, lmodel_twoside);
//	glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);  

	glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, front_mat_shininess);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, front_mat_specular);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, front_mat_diffuse);

    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT0, GL_POSITION, position0);
    glEnable(GL_LIGHT0);

    glLightfv(GL_LIGHT1, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT1, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT1, GL_POSITION, position1);
    glEnable(GL_LIGHT1);

    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
    glLightModelfv(GL_LIGHT_MODEL_TWO_SIDE, lmodel_twoside);
    glEnable(GL_LIGHTING);

    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, front_mat_shininess);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, front_mat_specular);
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, front_mat_diffuse);

}



/* ********************************************************************** */
void Init(void) 
{
	glClearColor (0.0, 0.0, 0.0, 0.0);
	glShadeModel (GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);		// corrects for depth

	glScalef (1.0, 1.0, 1.0);		// an axis independent scaling 

//	glMatrixMode(GL_MODELVIEW);

	InitMaterials();

}



/* ********************************************************************** */

/*void read_dxf_file (char *file_input)
{
//	extern char file_in_name[];
	file_in = fopen (file_input,"r");
	if (!file_in) {
		printf("  I couldn't read the input file: %s\n", file_input);
		exit(1);
 	}

	read_dxf();
}*/



/* ********************************************************************** */
void display(void)
{
	
	glLoadIdentity ();		// transform matrix clear

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
						// viewpoint setup
	gluLookAt (z_loc, y_loc, x_loc, 0, 0, 0, 0, 1, 0);

	glPushMatrix();			// ?

	glRotatef(x_rot_mouse, 0, 1, 0);
	glRotatef(y_rot_mouse, 1, 0, 0);

	glLineWidth(1);

	glutWireCube (1.0);			// a blank cube, at the origin

/*	glBegin(GL_POINTS);			// write points
		glVertex3f(0, 0, 0);
		glVertex3f(0.25, 0.25, 0.25);
		glVertex3f(0.25, 0.25, -0.25);
		glVertex3f(0.25, -0.25, 0.25);
		glVertex3f(0.25, -0.25, -0.25);
		glVertex3f(-0.25, 0.25, 0.25);
		glVertex3f(-0.25, 0.25, -0.25);
		glVertex3f(-0.25, -0.25, 0.25);
		glVertex3f(-0.25, -0.25, -0.25);
	glEnd();	*/

	glCallList(Data);

/*	glBegin(GL_LINES);			//write lines
		glVertex3f(0, -0.5, 0);		glVertex3f(-0.5, 0, 0);
		glVertex3f(0, -0.5, 0);		glVertex3f(0.5, 0, 0);
		glVertex3f(0, -0.5, 0);		glVertex3f(0, 0, -.5);
		glVertex3f(0, -0.5, 0);		glVertex3f(0, 0, 0.5);
		glVertex3f(0, 0.5, 0);		glVertex3f(-0.5, 0, 0);
		glVertex3f(0, 0.5, 0);		glVertex3f(0.5, 0, 0);
		glVertex3f(0, 0.5, 0);		glVertex3f(0, 0, -.5);
		glVertex3f(0, 0.5, 0);		glVertex3f(0, 0, 0.5);
		glVertex3f(0, 0, 0.5);		glVertex3f(-0.5, 0, 0);
		glVertex3f(0, 0, -0.5);		glVertex3f(0.5, 0, 0);
		glVertex3f(-0.5, 0, 0);		glVertex3f(0, 0, -0.5);
		glVertex3f(0.5, 0, 0);		glVertex3f(0, 0, 0.5);
	glEnd();         */

//	printf ("Screen refreshed.\n");
	glPopMatrix();
	glFlush ();
	glutSwapBuffers();
}



/* ********************************************************************** */
void reshape (int w, int h)
{
	glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.5, 50.0);
	glMatrixMode (GL_MODELVIEW);
}



/* ********************************************************************** */
/* ARGSUSED1 */
void keyboard(unsigned char key, int x, int y)
{
//	extern char *file_in_name[];
	switch (key) {
		case 'a': 
			x_loc += 0.25;	//slide right
			glutPostRedisplay();
			break;
		case 'd':
			x_loc -= 0.25;	//slide left
			glutPostRedisplay();
			break;
		case 'x':		//slide up
			y_loc -= 0.25;
			glutPostRedisplay();
			break;
		case 'w':		//slide left
			y_loc += 0.25;
			glutPostRedisplay();
			break;
		case 'e':		//slide up
			z_loc -= 0.25;
			glutPostRedisplay();
			break;
		case 'z':		//slide left
			z_loc += 0.25;
			glutPostRedisplay();
			break;
//		case 'v':		//reVerse normals
//			if (reverse_normals == 0)
//				reverse_normals = 1;
//			else
//				reverse_normals = 0;
//
//			printf("Reading DXF\n");	
//			read_dxf_file(file_in_name);
//			printf("Reposting Display\n");	
//			glutPostRedisplay();
//			break;
		case 27:		//quit program
			exit(0);
			break;
		case 'q':		//quit program
			exit(0);
			break;
	}
}



/* ********************************************************************** */
static void MouseMove( int x, int y )
{
   x_rot_mouse = y;
   y_rot_mouse = x;
   glutPostRedisplay();
}            

/* ********************************************************************** */
int main(int argc, char** argv)
{
//	extern char *file_in_name[];

//	file_in_name = argv[1];
	printf("%s\n",argv[1]);

	glutInit(&argc, argv);
	glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
	glutInitWindowSize (500, 500); 
	glutInitWindowPosition (100, 100);

//	Init();
	if (glutCreateWindow("DXF File Display") <= 0)	//name that window
		exit(0);				//quit if no window

	Init ();
	read_dxf_file (argv[1]);

	glutDisplayFunc(display); 
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);

	glutPassiveMotionFunc( MouseMove );      

	glutMainLoop();

	printf ("Ending main program...\n");

	return 0;
}


